#version 130
#define PI 3.1415926535
#define BPM 130.0
#define V vec3(0.,1.,-1.)
out vec2 gain;


//sb`vZ֐
float pitch(float p) {
return pow(1.059460646483, p) * 440.0;
}

// mCY쐬
float noiz(float s){
  return fract(sin(s*78.233)*43758.5453)*2.-1.;
}

//̍o͂iOq̃sb`֐𗘗pj
float tone( float note ){
	return 2.0*PI*pitch(note);
}

//mRMgo͂֐
float saw(float phase) {
 float s = 0.0;
 for (int k = 1; k <= 8; k++) {
 s += (sin(2.0*PI*float(k)*phase) / float(k));
 }
 return (1.0/2.0) - (1.0/PI)*s - 0.5;
}

//_ςo悤ɂĂB
vec4 random2H(vec2 _v) {
	return vec4(fract(sin(dot(_v, vec2(12.9898, 78.233))) * 43758.5453));
}

//vec2ł̃_֐ꕔ̒l
vec4 random(float _v) {
	return random2H(_v * V.yy);
}

//V[PX̒Pʂvvec4߂lƂ
vec4 sqc( float time, float tick ){
	
	/*=========|=========|=========|=========*/
	vec4 s_t;
	
	//qԂil̃JEgAȂɎgpj
	float s = mod(floor(time/240.*BPM*float(2)),4);

	//eBbNƂ̐lԂ
	float t = fract(time/240.*BPM*float(tick));
	
	//w肳ꂽqԂ
	float u = mod( floor( time/240.*BPM*float(tick)),tick );
	
	//ߐԂ
	float v = floor(time/240.*BPM);
	
	s_t.x = s;
	s_t.y = t;
	s_t.z = u;
	s_t.w = v;
	
	return s_t;
}

//pbhF{V[PX
float pad( float time,float semi){
	float s = 0.0; float semitones[4];
	semitones[0] = 0.0; semitones[1] = 4.0;
	semitones[2] = 7.0; semitones[3] =9.0;

	const int VOICES = 4;
	
	//ʃJE^
	//itF1ߓ̓񕪉̃JEgAt2Fʂ̌oߎԁj
	float t1 = mod(floor(time/240.*BPM*float(2)),4);
	float t2 = fract(time/240.*BPM*float(2));
	float t3 = (t1>= 2)?1.:0;
	
	float main_seq[4];
	main_seq[0]=0,main_seq[1]=0,main_seq[2]=3,main_seq[3]=3;
	

	vec4 sq = sqc(time, .5);

	//F
	for (int i = 0 ; i < 4; i++) {
	 
	 float q = mod(sq.w,4);
	 
	 	//sb`̕ύX
		 float f = pitch(-2+semi+main_seq[int(q)]+(semitones[i]));
		 
		 const int UNISON = 8;
		 for (int u = 0; u < UNISON-1; u++) {
		 
			 float fu = float(u);
			 float new_f = f + fu * sin(fu);
		
			//f[^
			 s += saw(time * new_f) * (1.0/float(UNISON))
			 * (1./float(VOICES))
			 *min(1, sq.y*6)	//A^bN
			 *max(0, 1.5-sq.y) //fBPC
			 ;	//
		 }
	 }

	 return s;
}

float kick(float time){
	float s = 0.;
	
	vec4 sq1 = sqc(time,4);
	vec4 sq2 = sqc(time,8);
	
	//qԂ
	float t1 = sq1.x;
	float t3 = sq2.x;
	
	//eBbNƂ̑傫Ԃ
	float t2 = sq1.y;
	float t4 = sq2.y;
	
	float t_r = t2;
	t_r = ( sq2.z>=7 && mod(sq1.x,4) == 3 )?t4:t2;
	
	float f = pitch(9-t2*35.);
	

	//t_r = ()?t4:t2;
	
	//ŏIIȃsb`
	s += sin(t_r*f)
	*min(1, t_r*6)	//A^bN
	*exp(-t_r*8.7)//*max(0, 1-t2*5.5)
	//*max(0,1-t_r)
	;
	
	return s;
}

float hihat(float time ) {
	vec4 sq = sqc( time, 16.);
	
	float _seed = sq.y,_dec = _seed*18.;
	return (random(_seed).x + random(_seed + _dec).x) * .5 * exp(-_dec/1.5) ;
}

float snare(float time,float flag) {
	vec4 sq = sqc( time, 16.);
	vec4 sq2 = sqc( time,4);
	
	float _seed = sq.y,_dec = _seed*7.5;
	flag = (mod(sq.w,16) == 15)?1.0:flag;
	flag = (mod(sq.w,8) == 7 && mod(sq.z, 16) > 7)?1.0:flag;
	flag = (mod(sq.w,4) ==3 && mod(sq.z, 16) > 13)?1.0:flag;
	
	float s = 0.;
	s = (mod(sq.z,8) != 4 )?0.:(random(_seed).x*1.5 ) * 1.3 * exp(-_dec/3.);
	//s += (sq2.x > 4. )?(random(_seed).x*1.5 ) * 1.5 * exp(-_dec/4.5) : 0;
	
	s = (flag ==1.0) ? (random(_seed).x*1.5 ) * 1.5 * exp(-_dec/4.5): s;
	
	
	return s*0.7;
}

float bassline(float time,float semi ){

	float ptn[16];
	ptn[0]=0,ptn[1]=0,ptn[2]=12,ptn[3]=0,
	ptn[4]=0,ptn[5]=0,ptn[6]=0,ptn[7]=12,
	ptn[8]=0,ptn[9]=0,ptn[10]=0,ptn[11]=0,
	ptn[12]=12,ptn[13]=0,ptn[14]=0,ptn[15]=0;
	
	vec4 sq = sqc( time, 16.);
	
	//semi = (mod(sq.w,4)>2)?semi:semi;
	
	float bs_note = -21.+semi;
	bs_note =(mod(sq.x,4) ==2.)?bs_note-7.:bs_note;
	bs_note =(mod(sq.x,4) ==3.)?bs_note-5.:bs_note;
	
	int tick = int(sq.z);
	float note = (ptn[tick] != 44)?bs_note + ptn[tick]:0.;
	
	float t1 = (ptn[tick]==44)? 0. :(sin(tone(note)*time) );
	float a = 2.5*sq.y;
	t1 = t1*min(1, sq.y*1)	//A^bN
	//*(exp(-sq.y*2.));	//tF[hAEg
	*max(0, 1-sq.y) //fBPC
	;
	
	return t1;
}

float sq2( float time){
	float ptn[16];
	
	ptn[0]=0,ptn[1]=0,ptn[2]=7,ptn[3]=0,
	ptn[4]=0,ptn[5]=7,ptn[6]=0,ptn[7]=0,
	ptn[8]=7,ptn[9]=0,ptn[10]=0,ptn[11]=7,
	ptn[12]=0,ptn[13]=0,ptn[14]=7,ptn[15]=0;
	
	vec4 sq = sqc( time, 16.);
	float bs_note = -3.;
/*	
	bs_note =(mod(sq.x,4) ==2.)?bs_note-5.:bs_note;
	bs_note =(mod(sq.x,4) ==3.)?bs_note-4.:bs_note;
	//bs_note = (mod(sq.x,2)==1)?bs_note-3:bs_note;
	*/
	
	int tick = int(sq.z);
	float note = (ptn[tick] != 44)?bs_note + ptn[tick]:0.;
	
	float t1 = (ptn[tick]==44)? 0. :(saw(pitch(note)*(time+sin(time*pitch(note/2))) ) );
	//float a = 1.*sq.y;
	t1 = t1//*((a>1.0)?1.0:a)
	*(exp(-sq.y*8.));	//tF[hAEg

	return t1;
}

float sq3( float time,float semi){
	vec4 sq = sqc( time, 1.);
	
	float bs_note = -3.+semi;
		float note =200.;
	
	float t1 =(saw(pitch(note)*(sin(pitch(note/2)*sq.y)) ) );
	t1 = ( mod(sq.w,4)==0)?t1:0;
	/*float a = 16.*sq.y;
	t1 = t1*((a>1.0)?1.0:a)
	*(exp(-sq.y*9.));	//tF[hAEg
	*/
			t1 *= max(0, 1-sq.y*2); //fBPC
	return t1;
}

vec2 mixer(float t) {
	vec2 s=vec2(0.);
	
	float semi = 0.;
	float count = floor(t/240.*BPM);
	vec4 sq =sqc(t,2);
	
	float tr[10];
	for( int i=0;i<9;i++){
		tr[i] = 0.0;
	}
	//ʏV[PX===================================================
	
	float cr = 1.;
	float s_roll = 0.;
	float smt=0.;
	semi = (count>1)?semi-3:semi;
	tr[0]=(count>1)?1.:0.;
	tr[1] = (count>1)?1.:0.;
	tr[6] = (count>11)?1.:0.;
	tr[7] = (count>15)?1.:0.;
	tr[8] = (count>18)?1.:0.;
	tr[2] = (count>19)?1.:0.;
	//tr[3] = (count>23)?1.:0.;
	
	//]p[g
	semi = (count>31)?semi-2:semi;//
	semi = (count>39)?semi+1:semi;//1:13
	semi = (count>47)?semi+2:semi;//1:29

	tr[6] =(count>59)?0.:tr[6];
	tr[7] =(count>59)?0.:tr[7];
	tr[8] =(count>59)?0.:tr[8];
	tr[2] =(count>60)?0.:tr[2];
	
	tr[0]=(count>67)?0.:tr[0];
	tr[1] = (count>67)?0.:tr[1];
	

	//ʏV[PX===================================================
	
	s += tr[0]*pad(t, semi)*vec2(.9,.4);
	s += tr[0]*pad(t+.24, semi)*vec2(.3,.8);
	s += tr[0]*pad(t+.48, semi)*vec2(.5,.5);

	s += tr[1]*bassline(t, semi)*vec2(.55);
	s += tr[1]*bassline(t+.008, semi)*vec2(.28);
	
	s += tr[7]*sq2(t)*vec2(.5);
	s += tr[2]*sq3(t, semi)*vec2(.0,.4);
	
	//s += sq4(t,smt)*vec2(0.4);
	
	s += tr[6]*kick(t)*vec2(1.)*.85;
	//s += tr[7]*hihat(t)*vec2(.82,.2)*.35;
	s += tr[8]*snare(t,s_roll)*vec2(.2,.8)*.5;
	
	//tF[hCB
	float fade_in = t*.05;
	fade_in = (fade_in>.8)?.8:fade_in;

	float f_o =1.;
	if(count==67){
		
		f_o = (sq.x==3)?(1-sq.y):f_o;
	}
	f_o = (count>67)?0:f_o;

	return vec2(s)* fade_in*f_o;
}
void main() 
{
	float t = gl_VertexID / 44100.;
	gain.x = (abs(gain.x)>.85)?gain.x*.2:gain.x;
	gain.y = (abs(gain.y)>.85)?gain.y*.2:gain.y;
	
	gain = mixer(t) * 1.;
}






